#ifndef ClientNetworkNode_H
#define ClientNetworkNode_H

#include <winsock2.h>
#include <list>
#include <Ogre.h>
#include <string>

using namespace std;

class ClientNetworkNode
{
public:
	ClientNetworkNode() { initialized = false; connected = false; };
	virtual ~ClientNetworkNode();

	void start();

	// called by "start()"
	void initSockets(); 

	// should be called before readPacket()
	bool hasMorePackets();

	// should be called each frame (in a loop with hasMorePackets() )
	int readPacket(sockaddr_in * senderAddress, char * readBuffer, int readBufferMaxSize);

	// try to connect
	void connect(string address, string playername);

	void reconnect(string playername);

	void disconnect( const string & playername );

	// send data
	int sendToServer(const char * data, const int dataSize);

	// packet handling routines! - important
	void handlePacketConnectionAccepted(sockaddr_in * senderAddress, const char data[], const int dataSize);

	void stop();

	bool isInitialized() { return initialized; };
	bool isConnected() { return connected; };

private:
	bool initialized;
	bool connected;

	u_short mPortNumber;

	sockaddr_in mClientSockAddr;
	sockaddr_in mServerSockAddr;
	SOCKET mSocket;



};

#endif
