#ifndef GameOverState_H
#define GameOverState_H

#include <Ogre.h>
#include <OIS/OIS.h>
#include <MyGUI.h>

#include "ClientGameState.h"

class GameOverState : public ClientGameState
{
public:

    ~GameOverState( void );
	void enter( void );
    void exit( void );

    void pause( void );
    void resume( void );
    void update( unsigned long lTimeElapsed );

    void keyPressed( const OIS::KeyEvent &e );
    void keyReleased( const OIS::KeyEvent &e );

    void mouseMoved( const OIS::MouseEvent &e );
    void mousePressed( const OIS::MouseEvent &e, OIS::MouseButtonID id );
    void mouseReleased( const OIS::MouseEvent &e, OIS::MouseButtonID id );

	
	void buttonRequestShutdown(MyGUI::WidgetPtr _widget);
	void buttonRequestReconnect(MyGUI::WidgetPtr _widget);

	static GameOverState* getSingletonPtr( void );

	bool isActive() { return mIsActive; };

private:
	GameOverState( void ) : mIsActive(false) { }
    GameOverState( const GameOverState& )  : mIsActive(false) { }
    GameOverState & operator = ( const GameOverState& );

	bool mIsActive;

	void setupScene();

    Ogre::Root           *mRoot;
    Ogre::Camera         *mCamera;
    Ogre::SceneManager   *mSceneMgr;
    Ogre::Viewport       *mViewport;
	
    static GameOverState    *mGameOverState;

	MyGUI::Gui* mGUI;
	MyGUI::VectorWidgetPtr widgetPtr;
	
};
#endif