#ifndef IntroState_H
#define IntroState_H

#include <Ogre.h>
#include <OIS/OIS.h>
#include <MyGUI.h>

#include "ClientGameState.h"

class IntroState : public ClientGameState
{
public:

    ~IntroState( void );
	void enter( void );
    void exit( void );

    void pause( void );
    void resume( void );
    void update( unsigned long lTimeElapsed );

    void keyPressed( const OIS::KeyEvent &e );
    void keyReleased( const OIS::KeyEvent &e );

    void mouseMoved( const OIS::MouseEvent &e );
    void mousePressed( const OIS::MouseEvent &e, OIS::MouseButtonID id );
    void mouseReleased( const OIS::MouseEvent &e, OIS::MouseButtonID id );

	
	void buttonRequestShutdown(MyGUI::WidgetPtr _widget);
	void buttonRequestConnect(MyGUI::WidgetPtr _widget);

	static IntroState* getSingletonPtr( void );

	bool isActive() { return mIsActive; };

private:
	IntroState( void ) : mIsActive(false) { }
    IntroState( const IntroState& )  : mIsActive(false) { }
    IntroState & operator = ( const IntroState& );

	bool mIsActive;

	void setupScene();

    Ogre::Root           *mRoot;
    Ogre::Camera         *mCamera;
    Ogre::SceneManager   *mSceneMgr;
    Ogre::Viewport       *mViewport;
	
    static IntroState    *mIntroState;

	MyGUI::Gui* mGUI;
	MyGUI::VectorWidgetPtr widgetPtr;
	
};
#endif