#ifndef SpringCam_H
#define SpringCam_H

#include <Ogre.h>

class SpringCam
{	
public:
	SpringCam::SpringCam();

	Ogre::Vector3 mCameraPos; ///<Cameras Position

	Ogre::Vector3 mDesiredPosition;//ideally behind player (0,50,-100);

	Ogre::Vector3 mVelocity;//Cameras Velocity

	Ogre::Vector3 mAcceleration;//Cameras Acceleration

	Ogre::Vector3 mDampenedVelocity;//Cameras Velocity after dampening

	Ogre::Vector3 mStretch;//Amount Camera Strecthed

	Ogre::Vector3 mForce;//Force applied to the camera
	

	float mStiffness;//Spring Stiffness

	float mDampening;//Spring Dampening

	float mMass;//Spring Mass


	void initSpringCam(Ogre::Vector3 camPos,Ogre::Vector3 offsetPos);///<Sets up a camera spring

	Ogre::Vector3 updateSpringCam(Ogre::Vector3 camPos,Ogre::Vector3 offsetPos, float _time);///<Updates the camera position
	Ogre::Vector3 updateSpringCam(Ogre::Vector3 camPos,Ogre::Vector3 offsetPos, float _time, float stiffness, float dampening, float mass);///<Updates the camera position

	float getMass(){return mMass;}//Inline get Mass function

	float getDampening(){return mDampening;}//Inline get Dampening function

	float getStiffness(){return mStiffness;}//Inline get Stiffness function

	void setMass(float mass){mMass = mass;}//Inline set Mass function

	void setDampening(float dampening){mDampening = dampening;}//Inline set Dampening function

	void setStiffness(float stiffness){mStiffness = stiffness;}//Inline set Stiffness function

	static SpringCam* getInstance() { return &mSpringCam; }//Get Instance of SpringCam

private:

	static SpringCam mSpringCam;//Static Instance of mSpringCam
	
};
#endif