#ifndef MenuState_H
#define MenuState_H

#include <Ogre.h>
#include <OIS/OIS.h>
#include <MyGUI.h>

#include "ServerGameState.h"

class MenuState : public ServerGameState
{
public:

    ~MenuState( void );
	void enter( void );
    void exit( void );

    void pause( void );
    void resume( void );
    void update( unsigned long lTimeElapsed );

    void keyPressed( const OIS::KeyEvent &e );
    void keyReleased( const OIS::KeyEvent &e );

    void mouseMoved( const OIS::MouseEvent &e );
    void mousePressed( const OIS::MouseEvent &e, OIS::MouseButtonID id );
    void mouseReleased( const OIS::MouseEvent &e, OIS::MouseButtonID id );

	
	void buttonRequestShutdown(MyGUI::WidgetPtr _widget);
	void buttonRequestStartServer(MyGUI::WidgetPtr _widget);
	static MenuState* getSingletonPtr( void );


private:
	MenuState( void ) { }
    MenuState( const MenuState& ) { }
    MenuState & operator = ( const MenuState& );

	void setupScene();

    Ogre::Root           *mRoot;
    Ogre::Camera         *mCamera;
    Ogre::SceneManager   *mSceneMgr;
    Ogre::Viewport       *mViewport;
	
    static MenuState    *mMenuState;

	MyGUI::Gui* mGUI;
	MyGUI::VectorWidgetPtr widgetPtr;
};
#endif