#ifndef PlayState_H
#define PlayState_H

#include <Ogre.h>
#include <OIS/OIS.h>
#include <MyGUI.h>

#include "ServerGameState.h"

class PlayState : public ServerGameState
{
public:

    ~PlayState( void );
	void enter( void );
    void exit( void );

    void pause( void );
    void resume( void );
    void update( unsigned long lTimeElapsedInMilis );

    void keyPressed( const OIS::KeyEvent &e );
    void keyReleased( const OIS::KeyEvent &e );

    void mouseMoved( const OIS::MouseEvent &e );
    void mousePressed( const OIS::MouseEvent &e, OIS::MouseButtonID id );
    void mouseReleased( const OIS::MouseEvent &e, OIS::MouseButtonID id );

	void buttonRequestCreateEnemy(MyGUI::WidgetPtr _widget);

	static PlayState* getSingletonPtr( void );


private:
	PlayState( void ) { }
    PlayState( const PlayState& ) { }
    PlayState & operator = ( const PlayState& );

	void setupScene();

    Ogre::Root           *mRoot;
    Ogre::Camera         *mCamera;
    Ogre::SceneManager   *mSceneMgr;
    Ogre::Viewport       *mViewport;
	
    static PlayState    *mPlayState;

	MyGUI::Gui* mGUI;
	MyGUI::VectorWidgetPtr widgetPtr;

	//MyGUI::StaticTextPtr ipText;
	MyGUI::StaticTextPtr deadReckoningText;
	MyGUI::StaticTextPtr packetLossText;
	MyGUI::StaticTextPtr infoText;
};
#endif
