
#include <Ogre.h>
#include <MyGui.h>

#include "GuiManager.h"

// ============================================================================
GuiManager::GuiManager( void )
{
	mGui = new MyGUI::Gui();
	this->init();
}
// ============================================================================
void GuiManager::shutdown( void )
{
	if(mGui)
	{
		mGui->shutdown();
		delete mGui;
		mGui = 0;
	}
}
// ============================================================================
GuiManager::~GuiManager( void )
{
	this->shutdown();
}
// ============================================================================
GuiManager & GuiManager::getSingleton()
{
	static GuiManager instance;
    return instance;
}
// ============================================================================
MyGUI::Gui * GuiManager::getGuiPtr()
{
	return mGui;
}
// ============================================================================
void GuiManager::init()
{
	mGui->initialise(Ogre::Root::getSingleton().getAutoCreatedWindow());
}
