
#ifndef packetID_H
#define packetID_H

#include <Ogre.h>
#include <Winsock2.h>
// ============================================================================
#define MAXBUFFERSIZE 65527
#define MAXPLAYERNAMESIZE 15
#define MAXENTITYIDSIZE 15
// ============================================================================
#define ID_Test					116 // 't'
#define	ID_Error				33	// '!'
#define	ID_Ping					112	// 'p' - Client pings the server
#define	ID_Pong					80	// 'P' - Server responds
// ============================================================================
#define	ID_RequestConnection	99	// 'c' - Client wants to connect to the server
/* [ID of the packet][String playername] */
// ============================================================================
#define	ID_ConnectionAccepted	67	// 'C' - Server accepts a connection
/* [ID of the packet][1 byte of colour][String playername] */
// ============================================================================
#define ID_SendNewPlayerData	78  // 'N' - Server sends a new player's data
/*
[Packet ID] = 1 byte
[Entity ID] = MAXENTITYIDSIZE bytes (default 15)
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)
[char Colour] = 1 byte
[Vec3 Position] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Quat Orientation] = 4 * 4 bytes = 16 bytes (W,X,Y,Z, float/reals)
[Vec3 Velocity] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Vec3 Acceler] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[float currPitchRotSpeed] = 4 bytes
[float currRollRotSpeed] = 4 bytes
[float currYawRotSpeed] = 4 bytes
[int Score] = 4 bytes
[int Lives] = 4 bytes

= to sum up... 103 bytes + 1 byte of Packet ID
*/
#define ID_SendNewPlayerData_Size 104
// ============================================================================
#define	ID_ServerCreatesEnemy			101	// 'e' - Server creates an enemy and sends the initial data
/*
[Packet ID] = 1 byte
[Entity ID] = MAXENTITYIDSIZE bytes (default 15)
[Vec3 Position] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Quat Orientation] = 4 * 4 bytes = 16 bytes (W,X,Y,Z, float/reals)
[Vec3 Velocity] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Vec3 Acceler] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
 = 68 bytes + 1 byte [ID]
*/
#define ID_ServerCreatesEnemy_Size 69
// ============================================================================
#define	ID_ServerDestroysEnemy			69	// 'E' - Server destroys an enemy
/*
[Packet ID] = 1 byte
[Entity ID] = MAXENTITYIDSIZE bytes (default 15)
*/
#define ID_ServerDestroysEnemy_Size (MAXENTITYIDSIZE+1)
// ============================================================================
#define	ID_UnknownEntity		117	// 'u' - Client doesn't know a certain entity ID (packet loss etc)
									//   - server should re-send IdCreateEntity to this client
/*
[ID of the packet][String unknown ID (max MAXENTITYIDSIZE bytes)]
*/
#define ID_UnknownEntity_Size (1+MAXENTITYIDSIZE)
// ============================================================================
#define	ID_EnemyData			68	// 'D' - Server updates enemy data, like new coordinates, velocity etc
/*
[Packet ID] = 1 byte
[Entity ID] = MAXENTITYIDSIZE bytes (default 15)
[Vec3 Position] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Quat Orientation] = 4 * 4 bytes = 16 bytes (W,X,Y,Z float/reals)
[Vec3 Velocity] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Vec3 Acceler] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)

= to sum up... 68 bytes + 1 byte of Packet ID
*/
#define	ID_EnemyData_Size 69
// ============================================================================
#define ID_PlayerRequestsCreateMissile		109 // 'm' - Client tries to launch a missile
/*
[Packet ID] = 1 byte
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)

= 15 bytes + 1 byte
*/
#define ID_PlayerRequestsCreateMissile_Size (1+MAXPLAYERNAMESIZE)
// ============================================================================
#define ID_ServerCreatesMissile		77 // 'M' - Server creates a requested missile
/*
[Packet ID] = 1 byte
[Owner name] = MAXPLAYERNAMESIZE bytes (default 15)
[Entity ID] = MAXENTITYIDSIZE bytes (default 15)
[Vec3 Position] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Quat Orientation] = 4 * 4 bytes = 16 bytes (W,X,Y,Z, float/reals)
[Vec3 Velocity] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Vec3 Acceler] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
 = 82 bytes + 1 byte [ID]
*/
#define ID_ServerCreatesMissile_Size (1+MAXPLAYERNAMESIZE+MAXENTITYIDSIZE+12+16+12+12)
// ============================================================================
#define ID_MissileData			83	// 'S' - Server sends missile data
/*
[Packet ID] = 1 byte
[Entity ID] = MAXENTITYIDSIZE bytes (default 15)
[Vec3 Position] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Quat Orientation] = 4 * 4 bytes = 16 bytes (W,X,Y,Z, float/reals)
[Vec3 Velocity] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Vec3 Acceler] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
 = 67 bytes + 1 byte [ID]
*/
#define ID_MissileData_Size (1+MAXENTITYIDSIZE+12+16+12+12)
// ============================================================================
#define ID_PlayerData			108 // 'l' - (small L) Client sends its data
/*
[Packet ID] = 1 byte
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)
[Vec3 Position] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Quat Orientation] = 4 * 4 bytes = 16 bytes (W,X,Y,Z float/reals)
[Vec3 Velocity] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Vec3 Acceler] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[float currPitchRotSpeed] = 4 bytes
[float currRollRotSpeed] = 4 bytes
[float currYawRotSpeed] = 4 bytes

= to sum up... 80 bytes + 1 byte of Packet ID
*/
#define ID_PlayerData_Size 81
// ============================================================================
#define ID_ServerPlayerData			76 // 'L' - Server sends players data
/*
[Packet ID] = 1 byte
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)
[Vec3 Position] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Quat Orientation] = 4 * 4 bytes = 16 bytes (W,X,Y,Z float/reals)
[Vec3 Velocity] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[Vec3 Acceler] = 3 * 4 bytes = 12 bytes (3 floats, ie Ogre::Real)
[float currPitchRotSpeed] = 4 bytes
[float currRollRotSpeed] = 4 bytes
[float currYawRotSpeed] = 4 bytes

= to sum up... 80 bytes + 1 byte of Packet ID
*/
#define ID_ServerPlayerData_Size 81
// ============================================================================
#define ID_PlayerRequestsExit				120 // 'x' - Client disconnects
/*
[Packet ID] = 1 byte
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)
*/
#define ID_PlayerRequestsExit_Size (MAXPLAYERNAMESIZE+1)
// ============================================================================
#define ID_ServerNotifiesAboutPlayerExit	88 // 'X' - Server tells other players about disconnection
/*
[Packet ID] = 1 byte
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)
*/
#define ID_ServerNotifiesAboutPlayerExit_Size (MAXPLAYERNAMESIZE+1)
// ============================================================================
#define ID_ServerChangesPlayerScore			82 // 'R' - Server changes player score (missile hit?)
/*
[Packet ID] = 1 byte
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)
[int Score] = 4 bytes
*/
#define ID_ServerChangesPlayerScore_Size (MAXPLAYERNAMESIZE+1+4)
// ============================================================================
#define ID_ServerDestroysMissile		105 // 'I' - Server destroys a missile (enemy hit or out of fuel)
/*
[Packet ID] = 1 byte
[Entity ID] = MAXENTITYIDSIZE bytes (default 15)
*/
#define ID_ServerDestroysMissile_Size (MAXENTITYIDSIZE+1)
// ============================================================================
#define ID_ServerChangesPlayerLives			86 // 'V' - Server changes player lives (enemy hit?)
/*
[Packet ID] = 1 byte
[PlayerName] = MAXPLAYERNAMESIZE bytes (default 15)
[int Lives] = 4 bytes
*/
#define ID_ServerChangesPlayerLives_Size (MAXPLAYERNAMESIZE+1+4)
// ============================================================================
#endif
